// TEN HTML5 version
// (c) 2014 Cybermuse
// Arranger 古籏一浩
var score = 0;			// スコア（得点）を入れる変数
var count = 0;		// 数字オブジェクトの合計を入れる変数
var time = 0;	// ゲームオーバーまでの時間
var timerID = null;	// カウントダウンタイマーのIDを入れる変数
var firstClickFlag = false;	// 最初にクリックしたかどうかのフラグ
var gameFlag = true;	// ゲーム中かどうかのフラグ。trueならゲーム中。
var num = [ ];	// 数字を入れる配列変数を用意
var numXCount = 4;	// 横の数字の個数
var numYCount = 6;	// 縦の数字の個数
var NumObj = [ ];	// ●数値オブジェクトを入れるための配列変数
var NumStack = [ ];	// ●数字オブジェクトを入れるための配列。スタックとして使用する。
var canvas = document.getElementById("stage");	// canvas要素を取得する
var ctx = canvas.getContext("2d");	// 2dコンテキストを取得する
// 初期化処理
function init(){
	canvas.onclick = addNumber;	// canvas要素にクリックイベントを割り当てる
	count = setRandomValue(numXCount, numYCount);	// 戻り値は要素の総数
	time = 30;	// 30秒に設定する
	document.getElementById("timeString").innerHTML = time + "秒";	// 時間を表示する
}
// ランダムに値を設定する関数
function setRandomValue(w, h){
	num = [ ];	// 配列内容を消去する
	var len = w * h;	// 数字の総数
	// ランダムな値を設定する
	for(var i=0; i<len; i+=2){	// 数字の数だけ繰り返す
		var n = Math.floor(Math.random() * 9) + 1;	// 1〜9までの数値をランダムに生成する
		num.push(n);
		num.push(10 - n);
	}
	// 配列要素をシャッフルする
	for(var i=0; i<len; i++){
		var p1 = Math.floor(Math.random() * len);	// 要素の数の範囲で乱数を発生させる
		var p2 = Math.floor(Math.random() * len);	// 要素の数の範囲で乱数を発生させる
		var n = num[p1];	// 2つの要素の内容を入れ替える
		num[p1] = num[p2];
		num[p2] = n;
	}
	// 表示処理
	document.getElementById("clearMsg").style.visibility = "hidden";	// ステージクリアメッセージを消す
	NumObj = [ ];	// スタックを空にする
	for(var y=0; y<h; y++){	// 数字の数だけ繰り返す
		for(var x=0; x<w; x++){
			NumObj.push(new NumClass({	// ●オブジェクトを生成する
				num : num[x+y*w],
				x : x * 48 + 4,
				y : y * 48 + 10,
				id : x+y*w	// ●IDを配列変数の参照番号に対応させる
			}));
		}
	}
	return len;	// 数字の総数を返す
}
// ●数字オブジェクトのひな形（クラス）を定義する
function NumClass(obj){
	this.id = obj.id;	// IDを設定する
	this.x = obj.x | 1;	// X座標を設定する。指定がない場合は1にする。
	this.y = obj.y | 0;	// Y座標を設定する。指定がない場合は0にする。
	this.num = obj.num | 0;	// 数値を設定する。指定がない場合は0にする。
	this.opacity = obj.opacity | 1.0;	// 不透明度を設定する。指定がない場合は1.0にする。
	this.width = 48;	// 数字の画像の横幅
	this.height = 48;	// 数字の画像の縦幅
	this.flag = true;	// 消されたかどうかを示すフラグ。falseなら消された、trueなら消されていない
	// ●描画処理を行うメソッド
	this.drawNumber = function(){
		if (!this.flag){ return; }	// 消されているので表示処理はしない
		ctx.clearRect(this.x, this.y, this.width, this.height);	// 指定された範囲を消す
		var imgObj = document.getElementById("N"+this.num);	// HTMLファイル内の画像を指定する
		var saveOpacity = ctx.globalAlpha;	// 現在の不透明度を変数に保存する
		ctx.globalAlpha = this.opacity;	// 不透明度を設定する
		ctx.drawImage(imgObj, this.x, this.y);	// 指定した座標に数字の画像を描画する
		ctx.globalAlpha = saveOpacity;	// 元の不透明度に戻す
	}
	// ●消去処理を行うメソッド
	this.eraseNumber = function(){
		if (!this.flag){ return; }	// 消されているので消去処理はしない
		ctx.clearRect(this.x, this.y, this.width, this.height);	// 指定された範囲を消す
	}
	// ●クリックのチェックを行うメソッド
	this.check = function(x, y){
		if (!this.flag){ return; }	// 消されているのでチェック処理はしない
		if ((x < this.x) || (y < this.y) || (x > (this.x+this.width)) || (y > (this.y+this.height))){
			return;	// 範囲外ないので何もしない
		}
		NumStack.push(this.id);	// クリックされた自分自身のIDをスタックに積む
		this.opacity = 0.5;
		this.drawNumber();
		checkNumber();
	}
	this.drawNumber();
}
// ●Canvasがクリックされた時に呼び出す関数
function addNumber(evt){
	// ゲーム中かどうかを調べる
	if (gameFlag === false){ return; }	// ゲーム中でない場合は以後の処理をしない
	// 初めてのクリックかどうか調べる
	if (firstClickFlag === false){
		firstClickFlag = true;	// クリックされたらtrueにする
		timerID = setInterval("displayTimer()", 1000);	// 1秒ごと定期的にタイマー表示関数を呼び出す
	}
	// クリック座標をオブジェクトに渡す
	for(var i=0; i<NumObj.length; i++){
		NumObj[i].check(evt.offsetX, evt.offsetY);
	}
}
// ●合計を調べる関数
function checkNumber(){
	var total = 0;
	for(var i=0; i<NumStack.length; i++){
		total = total + NumObj[NumStack[i]].num;	// スタックに積まれている数字オブジェクトの値を読み出し加算する
	}
	if (total < 10){ return; }	// 合計が10未満なら何もしない
	if (total > 10){	// 合計が10より大きい場合はNGなので、これまでクリックした数字を元の不透明度に戻す
		for(var i=0; i<NumStack.length; i++){
			NumObj[NumStack[i]].opacity = 1.0;
			NumObj[NumStack[i]].drawNumber();
		}
		NumStack = [ ];	// スタックを空にする
		return;
	}
	// 合計が10なのでクリックした数字オブジェクトを消去する
	for(var i=0; i<NumStack.length; i++){
		NumObj[NumStack[i]].eraseNumber();
		NumObj[NumStack[i]].flag = false;
	}
	score = score + 1;	// スコア（得点）を追加する
	document.getElementById("score").innerHTML = score;	// スコア（得点）を表示する
	count = count - NumStack.length;	// 合計からクリックされた数を引く
	if (count === 0){	// 全部消したかどうか調べる
		document.getElementById("clearMsg").style.visibility = "visible";	// ステージクリアメッセージを表示する
		clearInterval(timerID);	// タイマーを停止する
		setTimeout(function(){	// 2秒後に表示されているメッセージを消すためのタイマー
			count = setRandomValue(numXCount, numYCount);	// 乱数値を設定する
			timerID = setInterval("displayTimer()", 1000);	// 1秒ごと定期的にタイマー表示関数を呼び出す
		}, 2000);
	}
	NumStack = [ ];	// スタックを空にする
	return;	// 関数から抜ける
}
// タイマーの表示処理
function displayTimer(){
	time = time - 1;
	document.getElementById("timeString").innerHTML = time + "秒";
	if (time < 1){	// 時間が1より少なくなったらゲームオーバー
		gameFlag = false;	// ゲーム停止をフラグで示す。falseならゲーム中ではない
		clearInterval(timerID);	// タイマーを停止する
		alert("ゲームオーバー");
	}
}
window.onload = init;	// データが完全に読み込まれたら初期化処理を呼び出す
